
##### Compile binaries for SourceForge


#############################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################
####
####
#### Script "compile_gmic_and_gmic-gimp_plugin_64_win_SourceForge.sh" pour compiler GMIC et le plugin G'MIC SourceForge pour Gimp avec les sources de GIT 
#### Ce script est trs simple :
####	- Il crase la version GIT prsente (Il n'ffectue pas de mise  jour).
####	- Il compile le plug-in.
####	- Il cre l'environnement complet du greffon dans le rpertoire GMIC-GIMP-PLUGIN-64bit-WIN (en crasant le rpertoire existant).
####	- Il cre l'environnement complet de GMIC dans le rpertoire GMIC-64bit-WIN (en crasant le rpertoire existant).
####	- Il cre l'archive gmic_gmic-gimp_win64.tar.xz 
#### 
#### Ce script "compile_gmic_and_gmic-gimp_plugin_64_win_SourceForge.sh" fonctionne avec l'environnement de compilation 64 bits Windows disponible sur : http://www.aljacom.com/~gmic/petit-msys-mingw-64bits-gimp28.7z
#### Il faut l'installer dans "C:\petit-msys-mingw-64bits-gimp28".
####
#### Utilisation :
####	- Dmarrer MSYS en cliquant sur "start_MSYS.bat".
####	- Entrer les deux lignes de commandes qui suivent.
####			cd /env
####			./compile_gmic_and_gmic-gimp_plugin_64_win_SourceForge.sh
####	- Il y a 70 oprations  effectuer. Attendre le message "FIN - END".
####	- L'ensemple pour faire fonctionner le plug-in est disponible dans le rpertoire "GMIC-GIMP-PLUGIN-64bit-WIN" ( C:\petit-msys-mingw-64bits-gimp28\GMIC-GIMP-PLUGIN-64bit-WIN ).
####	- L'ensemple pour faire fonctionner GMIC disponible dans le rpertoire "GMIC-64bit-WIN" ( C:\petit-msys-mingw-64bits-gimp28\GMIC-64bit-WIN ).
####
####
#### _______________________________________________________________________________________________________________________________________________________________________________________________
####
#### English translation
####
#### Script "compile_gmic_and_gmic-gimp_plugin_64_win_SourceForge.sh" to compile GMIC and the plugin G'MIC for Gimp SourceForge with sources from GIT
#### This script is very simple:
####	- It removes the GIT version on the computer (it does not perform the update).
####	- It compiles the plugin.
####	- It creates the entire environment for the plug-in in the "GMIC-GIMP-PLUGIN-64bit-WIN" directory (overwriting the existing directory)
####	- It creates the archive gmic_gmic-gimp_win64.tar.xz 
####
#### This script "compile_gmic_and_gmic-gimp_plugin_64_win_SourceForge.sh" works with 64-bit build environment for Windows available :  http://www.aljacom.com/~gmic/petit-msys-mingw-64bits-gimp28.7z
#### It must be installed in "C:\petit-msys-mingw-64bits-gimp28".
####
#### Use:
####	- Start MSYS clicking "start_MSYS.bat".
####	- Enter the two command lines that follow.
####			cd /env
####			./compile_gmic_and_gmic-gimp_plugin_64_win_SourceForge.sh
####	- There are 70 operations to be performed. Wait for the message "FIN - END".
####	- The plug-in is available in the "GMIC-GIMP-PLUGIN-64bit-WIN" directory ( C:\petit-msys-mingw-64bits-gimp28\GMIC-GIMP-PLUGIN-64bit-WIN ).
####	- GMIC is available in the "GMIC-64bit-WIN" directory ( C:\petit-msys-mingw-64bits-gimp28\GMIC-64bit-WIN ).
####
####
####
#### version 2SF   20131031  par samj Binaires / Binaries Type "SourceForge" jpeg dll for PNG
#### version 1SF   20131031  par samj Binaires / Binaries Type "SourceForge" without jpeg dll
#### version 1     20131030  par samj le 30 octobre 2013
####
####
####
#############################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################




#### Compilation de GMIC et du plug-in, cration de l'archive gmic_gmic-gimp_win64.tar.xz 

Nombre_Operations=70
Repertoire_GIT=/env/gmic
Repertoire_Source=/env/gmic/src
Repertoire_Plugin=/env/GMIC-GIMP-PLUGIN-64bit-WIN
Repertoire_GMIC=/env/GMIC-64bit-WIN


echo 01/$Nombre_Operations
rm -f -r $Repertoire_GIT

echo 02/$Nombre_Operations
cd /env

echo 03/$Nombre_Operations
git clone git://git.code.sf.net/p/gmic/source gmic

echo 04/$Nombre_Operations
cd $Repertoire_Source

echo 05/$Nombre_Operations
####  /mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_gimp.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -mtune=generic -Dcimg_use_vt100 -Dgmic_is_parallel -Dcimg_use_fftw3 -Dcimg_use_png -Dcimg_use_zlib -Dcimg_use_tiff -Dcimg_use_jpeg -Dcimg_display=0 -Dcimg_use_rng -Dgmic_gimp -Dgmic_float_only
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_gimp.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -mtune=generic -Dcimg_use_vt100 -Dgmic_is_parallel -Dcimg_use_fftw3 -Dcimg_use_png -Dcimg_use_zlib -Dcimg_use_tiff -Dcimg_display=0 -Dcimg_use_rng -Dgmic_gimp -Dgmic_float_only

echo 06/$Nombre_Operations
#### /mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_gimp gmic_gimp.cpp gmic_gimp.o `gimptool-2.0.exe --cflags` -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -mtune=generic -Dcimg_use_vt100 -Dgmic_is_parallel -Dcimg_use_fftw3 -Dcimg_use_png -Dcimg_use_zlib -Dcimg_use_tiff -Dcimg_use_jpeg -Dcimg_use_vt100 -Dcimg_display=0 -Dcimg_use_rng `gimptool-2.0.exe --libs` -L/mingw/lib -L/mingw/x86_64-w64-mingw32/lib -mwindows -lpthread -lm -lfftw3 -lpng16 -lz -ltiff -ljpeg
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_gimp gmic_gimp.cpp gmic_gimp.o `gimptool-2.0.exe --cflags` -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -mtune=generic -Dcimg_use_vt100 -Dgmic_is_parallel -Dcimg_use_fftw3 -Dcimg_use_png -Dcimg_use_zlib -Dcimg_use_tiff -Dcimg_use_vt100 -Dcimg_display=0 -Dcimg_use_rng `gimptool-2.0.exe --libs` -L/mingw/lib -L/mingw/x86_64-w64-mingw32/lib -mwindows -lpthread -lm -lfftw3 -lpng16 -lz -ltiff

echo 07/$Nombre_Operations
/mingw/bin/strip.exe gmic_gimp.exe

echo 08/$Nombre_Operations
rm -f $Repertoire_Source/gmic_gimp.o

echo 09/$Nombre_Operations
rm -f -r $Repertoire_Plugin

echo 10/$Nombre_Operations
mkdir $Repertoire_Plugin

echo 11/$Nombre_Operations
mkdir $Repertoire_Plugin/_gmic

echo 12/$Nombre_Operations
cp /mingw/bin/libfftw3-3.dll $Repertoire_Plugin

echo 13/$Nombre_Operations
cp /mingw/bin/libgcc_s_sjlj-1.dll $Repertoire_Plugin

echo 14/$Nombre_Operations
cp /mingw/bin/libjpeg-9.dll $Repertoire_Plugin

echo 15/$Nombre_Operations
cp /mingw/bin/liblzma-5__.dll $Repertoire_Plugin

echo 16/$Nombre_Operations
cp /mingw/bin/libpng16-16.dll $Repertoire_Plugin

echo 17/$Nombre_Operations
cp /mingw/bin/libstdc++-6.dll $Repertoire_Plugin

echo 18/$Nombre_Operations
cp /mingw/bin/libtiff-5.dll $Repertoire_Plugin

echo 19/$Nombre_Operations
cp /mingw/bin/pthreadGC2-w64.dll $Repertoire_Plugin

echo 20/$Nombre_Operations
cp /mingw/bin/zlib1.dll $Repertoire_Plugin

echo 21/$Nombre_Operations
cp /mingw/bin/zlib1__.dll $Repertoire_Plugin

echo 22/$Nombre_Operations
cp $Repertoire_Source/gmic_gimp.exe $Repertoire_Plugin

echo 23/$Nombre_Operations
rm -f $Repertoire_Source/gmic_gimp.exe

echo 24/$Nombre_Operations
cp /mingw/Preferences/plug-ins/_gmic/curl.exe $Repertoire_Plugin/_gmic

echo The plug-in GMIC-GIMP is compiled.
echo Now you have to be very patient because the compilation GMIC starts...

echo 25/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_bool.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -mtune=generic -Dgmic_is_parallel -Dcimg_display=2 -Dcimg_appname=\"gmic\" -Dcimg_use_zlib -Dcimg_use_png -Dcimg_use_jpeg -Dcimg_use_fftw3 -Dcimg_use_tiff -Dgmic_split_compilation -Dgmic_bool

echo 26/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_uchar.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -mtune=generic  -Dgmic_is_parallel -Dcimg_display=2 -Dcimg_appname=\"gmic\" -Dcimg_use_zlib -Dcimg_use_png -Dcimg_use_jpeg -Dcimg_use_fftw3 -Dcimg_use_tiff -Dgmic_split_compilation -Dgmic_uchar

echo 27/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_char.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -Dgmic_is_parallel -Dcimg_display=2 -Dcimg_appname=\"gmic\" -Dcimg_use_zlib -Dcimg_use_png -Dcimg_use_jpeg -Dcimg_use_fftw3 -Dcimg_use_tiff -Dgmic_split_compilation -Dgmic_char

echo 28/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_ushort.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -Dgmic_is_parallel -Dcimg_display=2 -Dcimg_appname=\"gmic\" -Dcimg_use_zlib -Dcimg_use_png -Dcimg_use_jpeg -Dcimg_use_fftw3 -Dcimg_use_tiff -Dgmic_split_compilation -Dgmic_ushort

echo 29/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_short.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -Dgmic_is_parallel -Dcimg_display=2 -Dcimg_appname=\"gmic\" -Dcimg_use_zlib -Dcimg_use_png -Dcimg_use_jpeg -Dcimg_use_fftw3 -Dcimg_use_tiff -Dgmic_split_compilation -Dgmic_short

echo 30/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_uint.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -Dgmic_is_parallel -Dcimg_display=2 -Dcimg_appname=\"gmic\" -Dcimg_use_zlib -Dcimg_use_png -Dcimg_use_jpeg -Dcimg_use_fftw3 -Dcimg_use_tiff -Dgmic_split_compilation -Dgmic_uint

echo 31/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_int.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -Dgmic_is_parallel -Dcimg_display=2 -Dcimg_appname=\"gmic\" -Dcimg_use_zlib -Dcimg_use_png -Dcimg_use_jpeg -Dcimg_use_fftw3 -Dcimg_use_tiff -Dgmic_split_compilation -Dgmic_int

echo 32/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_float.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -Dgmic_is_parallel -Dcimg_display=2 -Dcimg_appname=\"gmic\" -Dcimg_use_zlib -Dcimg_use_png -Dcimg_use_jpeg -Dcimg_use_fftw3 -Dcimg_use_tiff -Dgmic_split_compilation -Dgmic_float -Dgmic_main

echo 33/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic_double.o -c gmic.cpp -Dgmic_build -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -pipe -O3 -mms-bitfields -s -m64 -Wall -W -Dgmic_is_parallel -Dcimg_display=2 -Dcimg_appname=\"gmic\" -Dcimg_use_zlib -Dcimg_use_png -Dcimg_use_jpeg -Dcimg_use_fftw3 -Dcimg_use_tiff -Dgmic_split_compilation -Dgmic_double

echo 34/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic.exe gmic_bool.o gmic_uchar.o gmic_char.o gmic_ushort.o gmic_short.o gmic_uint.o gmic_int.o gmic_float.o gmic_double.o -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -lm -L/mingw/lib -L/mingw/x86_64-w64-mingw32/lib -s -m64 -lpthread -lm -lgdi32 -lfftw3 -lpng16 -lz -ltiff -ljpeg

echo 35/$Nombre_Operations
/mingw/bin/strip.exe gmic.exe

echo 36/$Nombre_Operations
/mingw/bin/x86_64-w64-mingw32-g++.exe -o gmic-silent.exe gmic_bool.o gmic_uchar.o gmic_char.o gmic_ushort.o gmic_short.o gmic_uint.o gmic_int.o gmic_float.o gmic_double.o -I/mingw/include -I/mingw/x86_64-w64-mingw32/include -lm -L/mingw/lib -L/mingw/x86_64-w64-mingw32/lib -s -m64 -mwindows -lpthread -lm -lgdi32 -lfftw3 -lpng16 -lz -ltiff -ljpeg

echo 37/$Nombre_Operations
/mingw/bin/strip.exe gmic-silent.exe

echo 38/$Nombre_Operations
rm -f $Repertoire_Source/gmic_bool.o

echo 39/$Nombre_Operations
rm -f $Repertoire_Source/gmic_char.o

echo 40/$Nombre_Operations
rm -f $Repertoire_Source/gmic_double.o

echo 41/$Nombre_Operations
rm -f $Repertoire_Source/gmic_float.o

echo 42/$Nombre_Operations
rm -f $Repertoire_Source/gmic_int.o

echo 43/$Nombre_Operations
rm -f $Repertoire_Source/gmic_short.o

echo 44/$Nombre_Operations
rm -f $Repertoire_Source/gmic_uchar.o

echo 45/$Nombre_Operations
rm -f $Repertoire_Source/gmic_uint.o

echo 46/$Nombre_Operations
rm -f $Repertoire_Source/gmic_ushort.o

echo 47/$Nombre_Operations
rm -f -r $Repertoire_GMIC

echo 48/$Nombre_Operations
mkdir $Repertoire_GMIC

echo 49/$Nombre_Operations
cp /mingw/bin/libfftw3-3.dll $Repertoire_GMIC

echo 50/$Nombre_Operations
cp /mingw/bin/libgcc_s_sjlj-1.dll $Repertoire_GMIC

echo 51/$Nombre_Operations
cp /mingw/bin/libjpeg-9.dll $Repertoire_GMIC

echo 52/$Nombre_Operations
cp /mingw/bin/liblzma-5__.dll $Repertoire_GMIC

echo 53/$Nombre_Operations
cp /mingw/bin/libpng16-16.dll $Repertoire_GMIC

echo 54/$Nombre_Operations
cp /mingw/bin/libstdc++-6.dll $Repertoire_GMIC

echo 55/$Nombre_Operations
cp /mingw/bin/libtiff-5.dll $Repertoire_GMIC

echo 56/$Nombre_Operations
cp /mingw/bin/pthreadGC2-w64.dll $Repertoire_GMIC

echo 57/$Nombre_Operations
cp /mingw/bin/zlib1.dll $Repertoire_GMIC

echo 58/$Nombre_Operations
cp /mingw/bin/zlib1__.dll $Repertoire_GMIC

echo 59/$Nombre_Operations
cp $Repertoire_Source/gmic.exe $Repertoire_GMIC

echo 60/$Nombre_Operations
cp $Repertoire_Source/gmic-silent.exe $Repertoire_GMIC

echo 61/$Nombre_Operations
cp /mingw/Preferences/plug-ins/_gmic/curl.exe $Repertoire_GMIC

echo 62/$Nombre_Operations
rm -f $Repertoire_Source/gmic.exe

echo 63/$Nombre_Operations
rm -f $Repertoire_Source/gmic-silent.exe

echo 64/$Nombre_Operations
rm -f $Repertoire_Source/Start_Terminal_With_Test_GMIC.bat

echo 65/$Nombre_Operations
echo -e "cmd /T:0f /E:ON /K \"prompt $G&&cls&&gmic -verbose - 256,256,1,4 -gimp_chessboard 32,32,0,0,0,1,0,0,0,255,255,255,255,255 -window -1,-1,0,-1,TEST -wait 500&&echo Current Directory = %CD%&&echo You can type or paste a command recognized by GMIC&&echo For example :    gmic 256,256,1,4 -gimp_chessboard 32,32,0,0,0,1,0,0,0,255,255,255,255,255\"\n" > Start_Terminal_With_Test_GMIC.bat

echo 66/$Nombre_Operations
cp $Repertoire_Source/Start_Terminal_With_Test_GMIC.bat $Repertoire_GMIC

echo 67/$Nombre_Operations
rm -f $Repertoire_Source/Start_Terminal_With_Test_GMIC.bat

echo GMIC is compiled.
echo Creating the  gmic_gmic-gimp_win64.tar.xz  archive...

echo 68/$Nombre_Operations
rm -f /env/gmic_gmic-gimp_win64.tar.xz

echo 69/$Nombre_Operations
/usr/bin/tar.exe -cf /env/gmic_gmic-gimp_win64.tar /env/GMIC-64bit-WIN /env/GMIC-GIMP-PLUGIN-64bit-WIN

echo 70/$Nombre_Operations
/usr/bin/xz.exe -ze /env/gmic_gmic-gimp_win64.tar


echo FIN - END